const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class OrganizationsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const organizations = await db.organizations.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    return organizations;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const organizationsData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const organizations = await db.organizations.bulkCreate(organizationsData, {
      transaction,
    });

    // For each item created, replace relation files

    return organizations;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const organizations = await db.organizations.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    updatePayload.updatedById = currentUser.id;

    await organizations.update(updatePayload, { transaction });

    return organizations;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const organizations = await db.organizations.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of organizations) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of organizations) {
        await record.destroy({ transaction });
      }
    });

    return organizations;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const organizations = await db.organizations.findByPk(id, options);

    await organizations.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await organizations.destroy({
      transaction,
    });

    return organizations;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const organizations = await db.organizations.findOne(
      { where },
      { transaction },
    );

    if (!organizations) {
      return organizations;
    }

    const output = organizations.get({ plain: true });

    output.users_organizations = await organizations.getUsers_organizations({
      transaction,
    });

    output.access_roles_organizations =
      await organizations.getAccess_roles_organizations({
        transaction,
      });

    output.ai_agents_organization =
      await organizations.getAi_agents_organization({
        transaction,
      });

    output.ai_agents_organizations =
      await organizations.getAi_agents_organizations({
        transaction,
      });

    output.alerts_organization = await organizations.getAlerts_organization({
      transaction,
    });

    output.alerts_organizations = await organizations.getAlerts_organizations({
      transaction,
    });

    output.automation_jobs_organization =
      await organizations.getAutomation_jobs_organization({
        transaction,
      });

    output.automation_jobs_organizations =
      await organizations.getAutomation_jobs_organizations({
        transaction,
      });

    output.campaigns_organization =
      await organizations.getCampaigns_organization({
        transaction,
      });

    output.campaigns_organizations =
      await organizations.getCampaigns_organizations({
        transaction,
      });

    output.compliance_audits_organization =
      await organizations.getCompliance_audits_organization({
        transaction,
      });

    output.compliance_audits_organizations =
      await organizations.getCompliance_audits_organizations({
        transaction,
      });

    output.compliance_issues_organization =
      await organizations.getCompliance_issues_organization({
        transaction,
      });

    output.compliance_issues_organizations =
      await organizations.getCompliance_issues_organizations({
        transaction,
      });

    output.expansion_plans_organization =
      await organizations.getExpansion_plans_organization({
        transaction,
      });

    output.expansion_plans_organizations =
      await organizations.getExpansion_plans_organizations({
        transaction,
      });

    output.infrastructure_statuses_organization =
      await organizations.getInfrastructure_statuses_organization({
        transaction,
      });

    output.infrastructure_statuses_organizations =
      await organizations.getInfrastructure_statuses_organizations({
        transaction,
      });

    output.invoices_organization = await organizations.getInvoices_organization(
      {
        transaction,
      },
    );

    output.invoices_organizations =
      await organizations.getInvoices_organizations({
        transaction,
      });

    output.market_signals_organization =
      await organizations.getMarket_signals_organization({
        transaction,
      });

    output.market_signals_organizations =
      await organizations.getMarket_signals_organizations({
        transaction,
      });

    output.onboarding_cases_organization =
      await organizations.getOnboarding_cases_organization({
        transaction,
      });

    output.onboarding_cases_organizations =
      await organizations.getOnboarding_cases_organizations({
        transaction,
      });

    output.patient_messages_organizations =
      await organizations.getPatient_messages_organizations({
        transaction,
      });

    output.patient_profiles_organizations =
      await organizations.getPatient_profiles_organizations({
        transaction,
      });

    output.platform_metrics_organization =
      await organizations.getPlatform_metrics_organization({
        transaction,
      });

    output.platform_metrics_organizations =
      await organizations.getPlatform_metrics_organizations({
        transaction,
      });

    output.pricing_strategies_organization =
      await organizations.getPricing_strategies_organization({
        transaction,
      });

    output.pricing_strategies_organizations =
      await organizations.getPricing_strategies_organizations({
        transaction,
      });

    output.revenue_summaries_organization =
      await organizations.getRevenue_summaries_organization({
        transaction,
      });

    output.revenue_summaries_organizations =
      await organizations.getRevenue_summaries_organizations({
        transaction,
      });

    output.subscriber_activities_organizations =
      await organizations.getSubscriber_activities_organizations({
        transaction,
      });

    output.subscriber_roles_organizations =
      await organizations.getSubscriber_roles_organizations({
        transaction,
      });

    output.subscribers_organization =
      await organizations.getSubscribers_organization({
        transaction,
      });

    output.subscribers_organizations =
      await organizations.getSubscribers_organizations({
        transaction,
      });

    output.support_tickets_organization =
      await organizations.getSupport_tickets_organization({
        transaction,
      });

    output.support_tickets_organizations =
      await organizations.getSupport_tickets_organizations({
        transaction,
      });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('organizations', 'name', filter.name),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.organizations.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('organizations', 'name', query),
        ],
      };
    }

    const records = await db.organizations.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
